=== roms/skiboot/doc/requirements.txt ===
sphinx
recommonmark
# docutils 0.15 has a syntax error. fun.
docutils == 0.14
